image: maven:3.6.3-jdk-8

variables:
  AWS_REGION: 'ca-central-1'
  APP_JAR_NAME: 'AutomaticOrdersApi-1.0.0.jar' 
  S3_BUCKET: 'migrate-order-asignation-to-lambda'
  STACK_NAME:  'AutomaticOrdersServerStackDev'
  
before_script:
  - mkdir -p $HOME/.m2/

stages:
  - build
  #- test
  - deploy

aplication_build:
  stage: build
  #tags:
  # - aws
  script:
    - mvn clean	package -B shade:shade
  artifacts:
    paths:
      - target/$APP_JAR_NAME
      
aplication_deploy:
  stage: deploy
  #tags:
  # - aws
  only:
    - master
  image: python:latest
  script:
  - pip install awscli
  - aws s3 cp template.yaml s3://$S3_BUCKET
  - aws s3 cp target/ s3://$S3_BUCKET/ --recursive --exclude "*" --include $APP_JAR_NAME
  - aws cloudformation package --template-file template.yaml --s3-bucket $S3_BUCKET --output-template packaged.yaml
  - aws cloudformation deploy --force-upload --template-file packaged.yaml --stack-name $STACK_NAME --region $AWS_REGION --capabilities CAPABILITY_IAM
  - aws cloudformation describe-stack-events --stack-name $STACK_NAME --region $AWS_REGION
